# class Prism::PinnedVariableNode

Represents the use of the ‘^` operator for pinning a variable in a pattern matching expression.

    foo in ^bar
           ^^^^

### Attributes

variable [R]

attr_reader variable: `LocalVariableReadNode` | `InstanceVariableReadNode` | `ClassVariableReadNode` | `GlobalVariableReadNode` | `BackReferenceReadNode` | `NumberedReferenceReadNode` | `ItLocalVariableReadNode` | `MissingNode`

### Public Class Methods

new (source, node_id, location, flags, variable, operator_loc)
Source

    # File lib/prism/node.rb, line 14512
    def initialize(source, node_id, location, flags, variable, operator_loc)
      @source = source
      @node_id = node_id
      @location = location
      @flags = flags
      @variable = variable
      @operator_loc = operator_loc
    end

Initialize a new `PinnedVariableNode` node.

type ()
Source

    # File lib/prism/node.rb, line 14586
    def self.type
      :pinned_variable_node
    end

Return a symbol representation of this node type. See ‘Node::type`.

### Public Instance Methods

=== (other)
Source

    # File lib/prism/node.rb, line 14592
    def ===(other)
      other.is_a?(PinnedVariableNode) &&
        (variable === other.variable) &&
        (operator_loc.nil? == other.operator_loc.nil?)
    end

Implements case-equality for the node. This is effectively == but without comparing the value of locations. Locations are checked only for presence.

accept (visitor)
Source

    # File lib/prism/node.rb, line 14522
    def accept(visitor)
      visitor.visit_pinned_variable_node(self)
    end

def accept: (`Visitor` visitor) -> void

child_nodes ()
Source

    # File lib/prism/node.rb, line 14527
    def child_nodes
      [variable]
    end

def `child_nodes`: () -> Array[nil | Node]

Also aliased as: deconstruct
comment_targets ()
Source

    # File lib/prism/node.rb, line 14537
    def comment_targets
      [variable, operator_loc] #: Array[Prism::node | Location]
    end

def `comment_targets`: () -> Array[Node | Location]

compact_child_nodes ()
Source

    # File lib/prism/node.rb, line 14532
    def compact_child_nodes
      [variable]
    end

def `compact_child_nodes`: () -> Array

copy (node_id: self.node_id, location: self.location, flags: self.flags, variable: self.variable, operator_loc: self.operator_loc)
Source

    # File lib/prism/node.rb, line 14542
    def copy(node_id: self.node_id, location: self.location, flags: self.flags, variable: self.variable, operator_loc: self.operator_loc)
      PinnedVariableNode.new(source, node_id, location, flags, variable, operator_loc)
    end

def copy: (?node_id: `Integer`, ?location: `Location`, ?flags: `Integer`, ?variable: `LocalVariableReadNode` | `InstanceVariableReadNode` | `ClassVariableReadNode` | `GlobalVariableReadNode` | `BackReferenceReadNode` | `NumberedReferenceReadNode` | `ItLocalVariableReadNode` | `MissingNode`, ?operator_loc: `Location`) -> `PinnedVariableNode`

deconstruct ()

def deconstruct: () -> Array[nil | Node]

Alias for: child_nodes
deconstruct_keys (keys)
Source

    # File lib/prism/node.rb, line 14550
    def deconstruct_keys(keys)
      { node_id: node_id, location: location, variable: variable, operator_loc: operator_loc }
    end

def `deconstruct_keys`: (Array keys) -> { node_id: `Integer`, location: `Location`, variable: `LocalVariableReadNode` | `InstanceVariableReadNode` | `ClassVariableReadNode` | `GlobalVariableReadNode` | `BackReferenceReadNode` | `NumberedReferenceReadNode` | `ItLocalVariableReadNode` | `MissingNode`, `operator_loc`: `Location` }

inspect ()
Source

    # File lib/prism/node.rb, line 14576
    def inspect
      InspectVisitor.compose(self)
    end

def inspect -> `String`

operator ()
Source

    # File lib/prism/node.rb, line 14571
    def operator
      operator_loc.slice
    end

def operator: () -> `String`

operator_loc ()
Source

    # File lib/prism/node.rb, line 14558
    def operator_loc
      location = @operator_loc
      return location if location.is_a?(Location)
      @operator_loc = Location.new(source, location >> 32, location & 0xFFFFFFFF)
    end

attr_reader `operator_loc`: `Location`

save_operator_loc (repository)
Source

    # File lib/prism/node.rb, line 14566
    def save_operator_loc(repository)
      repository.enter(node_id, :operator_loc)
    end

Save the `operator_loc` location using the given saved source so that it can be retrieved later.

type ()
Source

    # File lib/prism/node.rb, line 14581
    def type
      :pinned_variable_node
    end

Return a symbol representation of this node type. See ‘Node#type`.